#!/bin/bash


MESSAGE_SIZE=12
EXEC=ex
TIME=120
BONUS_POINTS=20
ERRORS_NUMBER=0

make
cd checker
make
cd ..

if test ! -x $EXEC; then
    echo "Execf file missing"
    exit 1
fi

sum=0

echo "testing same_class"
points=$(cd checker; ./unit_testing_checker same_class)
return=$?

if [[ $return -eq 0 ]]
then
    sum=$(($sum + $points ))
else
    echo "encountered segfault in same_class"
fi
echo



echo "testing get_random_samples"
points=$(cd checker; ./unit_testing_checker get_random_samples)
return=$?

if [[ $return -eq 0 ]]
then
    sum=$(($sum + $points ))
else
    echo "encountered segfault in get_random_samples"
fi
echo



echo "testing random_dimensions"
points=$(cd checker; ./unit_testing_checker random_dimensions)
return=$?

if [[ $return -eq 0 ]]
then
    sum=$(($sum + $points ))
else
    echo "encountered segfault in random_dimensions"
fi
echo



echo "testing compute_unique"
points=$(cd checker; ./unit_testing_checker compute_unique)
return=$?

if [[ $return -eq 0 ]]
then
    sum=$(($sum + $points ))
else
    echo "encountered segfault in compute_unique"
fi
echo



echo "testing get_split_as_indexes"
points=$(cd checker; ./unit_testing_checker get_split_as_indexes)
return=$?

if [[ $return -eq 0 ]]
then
    sum=$(($sum + $points ))
else
    echo "encountered segfault in get_split_as_indexes"
fi
echo

echo "total unit testing points: $sum/50"

echo

echo "testing precision"
timeout $TIME ./ex > result

if [ "$?" == "124" ]
then
    echo "TIMEOUT [$TIME s]"
else
    typeset -i points=$(cat result)
    echo "Algorithm points: $points"
    sum=$(($sum + $points ))
fi

echo

rm result
make clean
cd checker
make clean
cd ..

echo

echo "testing Bonus"
echo
echo "" > checkstyle.txt
for entry in $(pwd)/*
do
    if [[ -f $entry ]]; then
       ./cpplint.py "$entry" > checkstyle.txt       
       YOUR_BONUS=`cat checkstyle.txt | grep "Total errors found: "| tr -dc '0-9'`
       ERRORS_NUMBER=$(( $ERRORS_NUMBER + $YOUR_BONUS )) 
    fi
done


if [[ $ERRORS_NUMBER -gt "10" ]]
then
    
    echo -ne "\nFail\n\t\tYou have a total of $ERRORS_NUMBER coding style errors.\n"

else
    echo -ne "\nPass\n\tNone?\n\t\tWow, next level!"
    sum=$(($sum + $BONUS_POINTS ))
fi

echo

echo "TOTAL: $sum/100"

echo
