// copyright Luca Istrate, Andrei Medar

#include "decisionTree.h"
#include <algorithm>
#include <cassert>
#include <cmath>
#include <iostream>
#include <limits>
#include <memory>
#include <unordered_map>
#include <utility>
#include <vector>

using std::string;
using std::pair;
using std::vector;
using std::unordered_map;
using std::make_shared;

// structura unui nod din decision tree
// splitIndex = dimensiunea in functie de care se imparte
// split_value = valoarea in functie de care se imparte
// is_leaf si result sunt pentru cazul in care avem un nod frunza
Node::Node() {
    is_leaf = false;
    left = nullptr;
    right = nullptr;
}

void Node::make_decision_node(const int index, const int val) {
    split_index = index;
    split_value = val;
}

void Node::make_leaf(const vector<vector<int>> &samples,
                     const bool is_single_class) {
    // TODO
    // Seteaza nodul curent ca fiind un nod de tip frunza
    // Daca is_single_class == true -> toate testele au aceeasi clasa
    // Daca is_single_class == false -> se alege clasa care apare cel mai des
}

pair<int, int> find_best_split(const vector<vector<int>> &samples,
                               const vector<int> &dimensions) {
    // TODO
    // Intoarce cea mai buna dimensiune si valoare de split dintre testele
    // primite
    // daca toate spliturile au un copil gol, atunci considerat split_index-ul
    // returnat -1
    // pair-ul este format din (split_index, split_value)
}

void Node::train(const vector<vector<int>> &samples) {
    // TODO
    // Antreneaza nodul curent si copii sai, daca e nevoie
}

int Node::predict(const vector<int> &image) const {
    // TODO
    // Intoarce rezultatul prezis de catre decision tree
}

bool same_class(const vector<vector<int>> &samples) {
    // TODO
    // Verifica daca testele primite ca argument au toate aceeasi clasa
    // Este folosit pentru a determina daca mai continua cu split-uri
}

float get_entropy(const vector<vector<int>> &samples) {
    // Intoarce entropia testelor primite ***
    assert(!samples.empty());
    vector<int> indexes;

    int size = samples.size();
    for (int i = 0; i < size; i++) indexes.push_back(i);

    return get_entropy_by_indexes(samples, indexes);
}

float get_entropy_by_indexes(const vector<vector<int>> &samples,
                             const vector<int> &index) {
    // TODO
    // Intoarce entropia subsetului din setul de teste total(samples)
    // Cu conditia ca subsetul sa contina testele ale caror indecsi se gasesc in
    // vectorul index
    // Se considera doar liniile din vectorul index ***
}

vector<int> compute_unique(const vector<vector<int>> &samples, const int col) {
    // TODO
    // Intoarce toate valorile (se elimina duplicatele)
    // Care apar in setul de teste, pe coloana col
}

pair<vector<vector<int>>, vector<vector<int>>> split(
    const vector<vector<int>> &samples, const int split_index,
    const int split_value) {
    // Intoarce cele 2 subseturi de teste obtinute in urma separarii
    // In functie de split_index si split_value
    vector<vector<int>> left, right;

    auto p = get_split_as_indexes(samples, split_index, split_value);
    for (const auto &i : p.first) left.push_back(samples[i]);
    for (const auto &i : p.second) right.push_back(samples[i]);

    return pair<vector<vector<int>>, vector<vector<int>>>(left, right);
}

pair<vector<int>, vector<int>> get_split_as_indexes(
    const vector<vector<int>> &samples, const int split_index,
    const int split_value) {
    // TODO(you)
    // Intoarce indexii sample-urilor din cele 2 subseturi obtinute in urma
    // separarii
    // In functie de split_index si split_value
}

vector<int> random_dimensions(const int size) {
    // TODO(you)
    // Intoarce sqrt(size) dimensiuni diferite pe care sa caute splitul maxim
    // Precizare: Dimensiunile gasite sunt > 0 si < size
}
